# ej2-diagrams

The diagram component visually represents information. It is also used to create diagrams like flow charts, organizational charts, mind maps, and BPMN either through code or a visual interface.

![Diagram](https://ej2.syncfusion.com/products/images/diagram/read-me.gif)

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's EULA (https://www.syncfusion.com/eula/es/). To acquire a license, you can purchase one at https://www.syncfusion.com/sales/products or start a free 30-day trial here (https://www.syncfusion.com/account/manage-trials/start-trials).

> A free community license (https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

## Setup

To install Diagram and its dependent packages, use the following command

```sh
npm install @syncfusion/ej2-diagrams  
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/documentation/diagram/getting-started.html?lang=typescript&utm_source=npm&utm_campaign=diagram)
* [View Online Demos](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/default-functionalities.html)
* [Product Page](https://www.syncfusion.com/javascript-ui-controls/diagram) 

## Supported Frameworks

Diagram component is also offered in following list of frameworks.

1. [Angular](https://github.com/syncfusion/ej2-angular-ui-components?utm_source=npm&utm_campaign=diagram)
2. [React](https://github.com/syncfusion/ej2-react-ui-components?utm_source=npm&utm_campaign=diagram)
3. [VueJS](https://github.com/syncfusion/ej2-vue-ui-components?utm_source=npm&utm_campaign=diagram)
4. [ASP.NET Core](https://aspdotnetcore.syncfusion.com/Diagram/FlowChart#/material)
5. [ASP.NET MVC](https://aspnetmvc.syncfusion.com/Diagram/DefaultFunctionalities#/material)
6. [JavaScript (ES5)](https://www.syncfusion.com/javascript-ui-controls/diagram)

## Showcase samples

* Diagram Builder ([Source](https://github.com/syncfusion/ej2-showcase-ng-diagrambuilder), [Live Demo](https://ej2.syncfusion.com/showcase/angular/diagrambuilder/))


## Key Features

- [**Nodes**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/getting-started-node.html)  - Nodes are used to host graphical objects (path or controls) that can be arranged and manipulated on a diagram page. Many predefined standard shapes are included. Custom shapes can also be created and added easily.
- [**Connectors**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/connector.html) - The relationship between two nodes is represented using a connector.
- [**Labels**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/getting-started-annotation.html)- Labels are used to annotate nodes and connectors.
- [**Interactive Features**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/drawing-tool.html) - Interactive features are used to improve the run time editing experience of a diagram.
- [**Data Binding**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/local-data.html) - Generates diagram with nodes and connectors based on the information provided from an external data source.
- [**Commands**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/key-board-functions.html) - Supports a set of predefined commands that helps edit the diagram using keyboard. It is also possible to configure new commands and key combinations.
- [**Automatic Layout**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/hierarchical-model.html) - Automatic layouts are used to arrange nodes automatically based on a predefined layout logic. There is built-in support for the organizational chart layout, hierarchical tree layout, symmetric layout, radial tree layout, and mind map layout.
- [**Overview Panel**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/overview.html) -  The overview panel is used to improve navigation experience when exploring large diagrams.
- [**SymbolPalettes**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/symbol-palette.html) - The symbol palette is a gallery of reusable symbols and nodes that can be dragged and dropped on the surface of a diagram.
- [**Rulers**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/drawing-tool.html) - The ruler provides horizontal and vertical guides for measuring diagram objects in diagram control.
- [**Serialization**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/serialization.html) - When saved in JSON format a diagram’s state persists, and then it can be loaded back using serialization.
- [**Exporting and Printing**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/print-export.html) - Diagrams can be exported as .png, .jpeg, .bmp, and .svg image files, and can also be printed as documents.
- [**Gridlines**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/default-functionalities.html) - Gridlines are the pattern of lines drawn behind diagram elements. It provides a visual guidance while dragging or arranging the objects on a diagram surface.
- [**Page Layout**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/print-export.html)- The drawing surface can be configured to page-like appearance using page size, orientation, and margins.
- [**Context Menu**](https://ej2.syncfusion.com/16.2.41/demos/#/material/diagram/key-board-functions.html) - Frequently used commands can easily be mapped to the context menu.

## Support

Product support is available for through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=diagram) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_campaign=diagram).
* New [GitHub issue](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2/blob/master/license?utm_source=npm&utm_campaign=diagram).

## Changelog

Check the changelog [here](https://ej2.syncfusion.com/javascript/documentation/release-notes/index)

© Copyright 2022 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.